const {chalkTag, fs, findPages} = require("./tools");
const axios = require("axios");
const PageBase = require("dvcp-wui/utils/PageBase");

let apps = {list: [], desc: "用于产品库主页面获取应用使用", type: 'mp'}
const saveApps = app => {
  if (app.list.length > 0) {
    return axios.post("http://192.168.1.87:12525/node/wechatapps/addOrUpdate", app, {timeout: 1000}).then(res => {
      if (res.data.code == 0) chalkTag.done("产品库目录已同步至后台数据库...")
    }).catch(err => {
      console.log(err)
    })
  }
}
const getFileInfo = (app, file) => {
  if (/^App/.test(app.name) && app.label) {
    let {name, label} = app,
        path = app.path.replace(/.+[\\\/]([^\\\/]+)[\\\/]([^\\\/]+)$/g, `/mods/$1/$2`)
    apps.list.push({
      id: file.replace(/\.\/?(vue)?/g, '').replace(/[\\\/]/g, '_'),
      name,
      label,
      path,
      libPath: file.replace(/[\\\/]/g, '/').replace(/^src(\/.+)\.vue/, '$1'),
      type: 'mp'
    })
  }
}
const start = () => {
  chalkTag.info('开始同步数据到数据库')
  Promise.all([
    findPages('src/components/pages', file => {
      if (/.+[\\\/]pages[\\\/][^\\\/]+\.vue/g.test(file)) {
        const app = new PageBase(file.replace(/^src[\\\/]components[\\\/]pages[\\\/](.*).vue/g, '$1').replace(/[\\\/]/g, '/'), fs.readFileSync(file).toString())
        return getFileInfo(app, file)
      }
    }),
    findPages('src/mods', file => {
      if (/.+[\\\/]App[^\\\/]+[\\\/][^\\\/]+\.vue/g.test(file)) {
        const app = new PageBase(file.replace(/^src[\\\/]mods[\\\/](.*).vue/g, '$1').replace(/[\\\/]/g, '/'), fs.readFileSync(file).toString())
        return getFileInfo(app, file)
      }
    }),
    findPages('src/project', file => {
      if (/.+[\\\/]App[^\\\/]+[\\\/][^\\\/]+\.vue/g.test(file)) {
        const app = new PageBase(file.replace(/^src[\\\/]project[\\\/](.*).vue/g, '$1').replace(/[\\\/]/g, '/'), fs.readFileSync(file).toString())
        return getFileInfo(app, file)
      }
    })
  ]).then(() => saveApps(apps)).finally(() => chalkTag.done('同步完成'))
}
start()
